import processing.serial.*;
Serial myPort; 
String dataStr;   
String[] Str = new String[200];
int[] dataInt = new int[200]; 
int i;
int Sum;
char dataChar;
int n;
int j;
int charNo;
int saveNo;
 
void setup() {
  size(1000,100);
  background(0,102,165);
  myPort = new Serial(this, "COM2", 9600); //ポートと通信速度。ここでポート番号を合わせてください。
  saveNo = 1;

  PFont myFont;
  myFont = createFont("MSゴシック",20);
  textFont(myFont);
  fill(230,219,65);
  text("＜ 赤外線リモコンのパターン表示 ＞",50,18); 
  fill(254,237,176);   
  textSize(14);
  text("Arduinoに接続した赤外線モジュールにリモコンから赤外線を照射すると、約１秒後に信号のパターンを表示する。",50,35); 
  text("数秒間受信すると、0～1秒、1～2秒、2～3秒と順次表示する。",50,50);
  text("リモコンからの次の照射は１秒以上時間を空けてから行う。",50,65);
  text("点滅回数が画面右に表示される。",50,80);
  text("Sキーを押すと画像がフォルダ内に保存される。保存保存 No.○と画面右に表示される（○は連番になる）",50,95);

  frameRate(30); 
}
 
void draw() {
  if ( myPort.available() > 0) {
    delay(1000);                     //1秒間間を置く
    dataStr = myPort.readString();
    charNo = dataStr.length();
    n=0;
    for(j=0;j<charNo;j++){
        dataChar = dataStr.charAt(j);
        if(dataChar == ',')  n=n+1;
    }

    Str = split(dataStr,',');
    Sum = 0;
    fill(0);
    rect(0,0,1000,100);
    for(i=0;i<n-1;i++){
      if(i==199) break ; //199になったらfor文から抜ける
      dataInt[i] = int(Str[i]);
      Sum = Sum + dataInt[i];
      fill(255);
      strokeWeight(0);
      if(i%2 == 0)  rect((Sum-dataInt[i])/800,0,dataInt[i]/800,100);
    }

    fill(150,150,150);
    textSize(12);
    text("点滅回数 "+ int(n/2),920,15);  
  }
}
  
 void keyReleased(){
   if(key== 's'||key == 'S'){
     save("IR_" + saveNo + ".png");
     fill(200,200,0);
     textSize(14);
     text("保存 No."+ saveNo,920,40);
     saveNo = saveNo + 1 ;
   }
}

